package com.notuvy.singleapp;

import java.io.Serializable;

/**
 * Basic description
 *
 * @author murali
 */
public class DummyWebBrowser implements Runnable {

    //------------------------------------------------------------
    //- Class Variables

    static {
        System.setProperty("log4j.configuration", "singleapp_log4j.xml");
    }


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    private final String initialUrl;
    private boolean alive = true;


    //------------------------------------------------------------
    //- Constructors

    public DummyWebBrowser(String pInitialUrl) {
        initialUrl = pInitialUrl;
    }


    //------------------------------------------------------------
    //- Gettors


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions

    public void openURL(String pUrl) {
        System.out.println("URL: " + pUrl);
    }


    //------------------------------------------------------------
    //- Class Interface Functions

    public void run() {
        openURL(initialUrl);

        while (alive) {
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                // nothing
            }
        }
    }


    //------------------------------------------------------------
    //- Inner Classes

    static class Launcher extends AbstractSingleApp {
        private final DummyWebBrowser browser;

        Launcher( DummyWebBrowser pBrowser) {
            super(10431, Strategy.MULTI_USER_DEFER);
            browser = pBrowser;
        }

        public void run() {
            browser.run();
        }

        @Override
        public Serializable sendFromDeferred() {
            return browser.initialUrl;
        }

        @Override
        public void recvFromDeferred(Object pObject) {
            String url = (String) pObject;
            browser.openURL(url);
        }
    }


    //------------------------------------------------------------
    //- Main

    public static void main(String[] args) {
        DummyWebBrowser browser = new DummyWebBrowser(args[0]);
        Launcher launcher = new Launcher(browser);
        launcher.launch();
    }

}
